// MainFrame.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "xpce.h"
#include "MainFrame.h"
#include "dd.h"
#include "log.h"
#include "AboutDlg.h"
#include "archive.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define WM_DDINITIALIZE		(WM_APP + 4)
#define WM_CHANGEWINDOWMODE	(WM_APP + 5)

int main_loop(int argc,char *argv[]);

extern HANDLE	hEventEndCommand;
extern HANDLE	hEventNotify;
extern DWORD	dwEvent;
extern char		*pCartName;

#define EV_STOP			0x0001
#define EV_SAVE			0x0002
#define EV_LOAD			0x0004
#define EV_FULLSCREEN	0x0008
#define EV_ZOOM		0x0010
//#define EV_ZOOM2		0x0020
#define EV_RESET		0x0040
#define EV_CARTLOAD		0x0080
#define EV_DOWNSKIPRATE	0x0100
#define EV_UPSKIPRATE	0x0200
#define EV_AUTOFRAMESKIP	0x0400

int ksJoy1;
int ksJoy2;
int ksJoy11;
int ksJoy22;
int ksJoyRun;
int ksJoySel;
int ksKey1;
int ksKey2;
int ksKey11;
int ksKey22;
int ksKeyRun;
int ksKeySel;
int ksKeyDown;
int ksKeyUp;
int ksKeyLeft;
int ksKeyRight;

BOOL snd_bSound;
DWORD snd_dwSampleRate;
//DWORD snd_dwBits;
DWORD snd_dwChannels;
int snd_CoopMode;
int snd_Latency;

BOOL bShowFps;
BOOL bAutoFrameSkip;
int UPeriod;
int BaseClock;
BOOL MakeLog;

CString RomDir;
CString TempDir;
char save_dir[MAX_PATH];

static BOOL ksJoy1Err = TRUE;
static BOOL ksJoy2Err = TRUE;
static BOOL ksJoy11Err = TRUE;
static BOOL ksJoy22Err = TRUE;
static BOOL ksJoyRunErr = TRUE;
static BOOL ksJoySelErr = TRUE;
static BOOL ksKey1Err = TRUE;
static BOOL ksKey2Err = TRUE;
static BOOL ksKey11Err = TRUE;
static BOOL ksKey22Err = TRUE;
static BOOL ksKeyRunErr = TRUE;
static BOOL ksKeySelErr = TRUE;
static BOOL ksKeyDownErr = TRUE;
static BOOL ksKeyUpErr = TRUE;
static BOOL ksKeyLeftErr = TRUE;
static BOOL ksKeyRightErr = TRUE;

static BOOL snd_bSoundErr = TRUE;
static BOOL snd_dwSampleRateErr = TRUE;
//static BOOL snd_dwBitsErr = TRUE;
static BOOL snd_dwChannelsErr = TRUE;
static BOOL snd_CoopModeErr = TRUE;
static BOOL snd_LatencyErr = TRUE;

static BOOL bShowFpsErr = TRUE;
static BOOL bAutoFrameSkipErr = TRUE;
static BOOL UPeriodErr = TRUE;
static BOOL BaseClockErr = TRUE;
static BOOL MakeLogErr = TRUE;

static BOOL Mode0Err = TRUE;
static BOOL Mode1Err = TRUE;
static BOOL Mode2Err = TRUE;
static BOOL Mode3Err = TRUE;

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

CMainFrame::CMainFrame()
{
	lpDDraw = NULL;
	lpPrimarySurface = NULL;
	lpBackSurface = NULL;

	m_hPaletteOld = NULL;
	m_pMainThread = NULL;

	m_hMenu = ::LoadMenu(AfxGetApp()->m_hInstance, MAKEINTRESOURCE(IDR_MENU));
//#ifdef FULLSCREEN
#if 0
	RECT	rcWnd;
	rcWnd.left = 0;
	rcWnd.top = 0;
	rcWnd.right = GetSystemMetrics(SM_CXSCREEN);
	rcWnd.bottom = GetSystemMetrics(SM_CYSCREEN);

	Create(((CXpceApp *)AfxGetApp())->mainclass,
			"",		// EBhẼLvVw肵܂B
			WS_POPUP,
			rcWnd,
			NULL, NULL);
#else // FULLSCREEN
	RECT	rcWnd;
	rcWnd.left = 0;
	rcWnd.top = 0;
	rcWnd.right = 320 + GetSystemMetrics(SM_CXFIXEDFRAME)*2 + GetSystemMetrics(SM_CXEDGE)*2;
	rcWnd.bottom = 240 + GetSystemMetrics(SM_CYFIXEDFRAME)*2 + GetSystemMetrics(SM_CYEDGE)*2
					+ GetSystemMetrics(SM_CYCAPTION) + GetSystemMetrics(SM_CYMENU);

	Create(((CXpceApp *)AfxGetApp())->mainclass,
			"xpce",		// EBhẼLvVw肵܂B
			WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_BORDER | WS_MINIMIZEBOX,
			rcWnd,
			NULL, NULL);

	::SetMenu(m_hWnd, m_hMenu);
#endif // FULLSCREEN
}

CMainFrame::~CMainFrame()
{
}


BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_ACTIVATEAPP()
	ON_WM_MOVE()
	ON_WM_QUERYNEWPALETTE()
	ON_WM_PALETTECHANGED()
	ON_WM_INITMENU()
	ON_COMMAND(IDC_EXIT, OnExit)
	ON_COMMAND(IDC_FULLSCREEN, OnFullScreen)
	ON_COMMAND(IDC_LOAD, OnLoad)
	ON_COMMAND(IDC_SAVE, OnSave)
	ON_COMMAND(IDC_ZOOM1, OnZoom1)
	ON_COMMAND(IDC_RESET, OnReset)
	ON_COMMAND(IDC_OPEN, OnOpen)
	ON_COMMAND(IDC_ABOUT, OnAbout)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_DDINITIALIZE, OnDDInitialize)
	ON_MESSAGE(WM_CHANGEWINDOWMODE, OnChangeWindowMode)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainFrame bZ[W nh

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	strcpy(m_szCmdLine, AfxGetApp()->m_lpCmdLine);
	m_pCmdLine = strtok(m_szCmdLine, " \n\r\t\v");

	if (!LoadProfile())
	{
		PostMessage(WM_CLOSE);
		return 0;
	}

	PostMessage(WM_DDINITIALIZE);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs) 
{
	BOOL bRet = CFrameWnd::PreCreateWindow(cs);

	return bRet;
}

BOOL CMainFrame::LoadProfile()
{
	CString	str;
	int		ret;
	CWinApp	*pApp = AfxGetApp();
	char	*p;

#define LOAD_PROFILE_JOY(joy, szSection, szEntry, iDefault)\
		{\
			joy = pApp->GetProfileInt(szSection, szEntry, iDefault);\
			ret = CheckJoyRange(joy, szSection, szEntry);\
			if (ret < 0)\
			{\
				joy = iDefault;\
				if (ret < -1)\
					return FALSE;\
			}\
			else\
				joy##Err = FALSE;\
		}
	static TCHAR	szSectionJoy[] = _T("Joystick");
	LOAD_PROFILE_JOY(ksJoy1, szSectionJoy, _T("1"), 0);
	LOAD_PROFILE_JOY(ksJoy2, szSectionJoy, _T("2"), 1);
	LOAD_PROFILE_JOY(ksJoy11, szSectionJoy, _T("11"), 4);
	LOAD_PROFILE_JOY(ksJoy22, szSectionJoy, _T("22"), 5);
	LOAD_PROFILE_JOY(ksJoyRun, szSectionJoy, _T("Run"), 2);
	LOAD_PROFILE_JOY(ksJoySel, szSectionJoy, _T("Sel"), 3);

#define LOAD_PROFILE_KEY(key, szSection, szEntry, szDefault, defKeyCode)\
		{\
			str = pApp->GetProfileString(szSection, szEntry, szDefault);\
			ret = CheckKeyString(str, szSection, szEntry);\
			if (ret < 0)\
			{\
				key = defKeyCode;\
				if (ret < -1)\
					return FALSE;\
			}\
			else\
			{\
				key##Err = FALSE;\
				key = ret;\
			}\
		}
	static TCHAR	szSectionKey[] = _T("Keyboard");
	LOAD_PROFILE_KEY(ksKey1, szSectionKey, _T("1"), _T("Z"), 'Z');
	LOAD_PROFILE_KEY(ksKey2, szSectionKey, _T("2"), _T("X"), 'X');
	LOAD_PROFILE_KEY(ksKey11, szSectionKey, _T("11"), _T("A"), 'A');
	LOAD_PROFILE_KEY(ksKey22, szSectionKey, _T("22"), _T("S"), 'S');
	LOAD_PROFILE_KEY(ksKeyRun, szSectionKey, _T("Run"), _T("ENTER"), VK_RETURN);
	LOAD_PROFILE_KEY(ksKeySel, szSectionKey, _T("Sel"), _T("TAB"), VK_TAB);
	LOAD_PROFILE_KEY(ksKeyDown, szSectionKey, _T("Down"), _T("DOWN"), VK_DOWN);
	LOAD_PROFILE_KEY(ksKeyUp, szSectionKey, _T("Up"), _T("UP"), VK_UP);
	LOAD_PROFILE_KEY(ksKeyLeft, szSectionKey, _T("Left"), _T("LEFT"), VK_LEFT);
	LOAD_PROFILE_KEY(ksKeyRight, szSectionKey, _T("Right"), _T("RIGHT"), VK_RIGHT);

	static TCHAR	szSectionSound[] = _T("Sound");
	ret = pApp->GetProfileInt(szSectionSound, _T("Sound"), 1);
	if (ret != 0 && ret != 1)
	{
		ret = 0;
		if (-1 > ProfileError(szSectionSound, _T("Sound")))
			return FALSE;
	}
	else
		snd_bSoundErr = FALSE;
	snd_bSound = ret;

	ret = pApp->GetProfileInt(szSectionSound, _T("SampleRate"), 44100);
	if (ret < 1000 || 100000 <= ret)
	{
		ret = 44100;
		if (-1 > ProfileError(szSectionSound, _T("SampleRate")))
			return FALSE;
	}
	else
		snd_dwSampleRateErr = FALSE;
	snd_dwSampleRate = ret;

/*	ret = pApp->GetProfileInt(szSectionSound, _T("Bits"), 16);
	if (ret != 16 && ret != 8)
	{
		ret = 16;
		if (-1 > ProfileError(szSectionSound, _T("Bits")))
			return FALSE;
	}
	else
		snd_dwBitsErr = FALSE;
	snd_dwBits = ret;
*/
	ret = pApp->GetProfileInt(szSectionSound, _T("Channels"), 2);
	if (ret != 1 && ret != 2)
	{
		ret = 2;
		if (-1 > ProfileError(szSectionSound, _T("Channels")))
			return FALSE;
	}
	else
		snd_dwChannelsErr = FALSE;
	snd_dwChannels = ret;

	ret = pApp->GetProfileInt(szSectionSound, _T("CoopMode"), 2);
	if (ret < 0 && 2 < ret)
	{
		ret = 2;
		if (-1 > ProfileError(szSectionSound, _T("CoopMode")))
			return FALSE;
	}
	else
		snd_CoopModeErr = FALSE;
	snd_CoopMode = ret;

	ret = pApp->GetProfileInt(szSectionSound, _T("Latency"), 40);
	if (ret < 20 && 100 < ret)
	{
		ret = 40;
		if (-1 > ProfileError(szSectionSound, _T("Latency")))
			return FALSE;
	}
	else
		snd_LatencyErr = FALSE;
	snd_Latency = ret;

	static TCHAR	szSectionOthers[] = _T("Others");
	ret = pApp->GetProfileInt(szSectionOthers, _T("ShowFPS"), 0);
	if (ret != 0 && ret != 1)
	{
		ret = 0;
		if (-1 > ProfileError(szSectionOthers, _T("ShowFPS")))
			return FALSE;
	}
	else
		bShowFpsErr = FALSE;
	bShowFps = ret;

	ret = pApp->GetProfileInt(szSectionOthers, _T("AutoFrameSkip"), 1);
	if (ret != 0 && ret != 1)
	{
		ret = 0;
		if (-1 > ProfileError(szSectionOthers, _T("AutoFrameSkip")))
			return FALSE;
	}
	else
		bAutoFrameSkipErr = FALSE;
	bAutoFrameSkip = ret;

	ret = pApp->GetProfileInt(szSectionOthers, _T("FrameSkipCount"), 0);
	if (ret < 0 || 60 < ret)
	{
		ret = 0;
		if (-1 > ProfileError(szSectionOthers, _T("FrameSkipCount")))
			return FALSE;
	}
	else
		UPeriodErr = FALSE;
	UPeriod = ret;

	ret = pApp->GetProfileInt(szSectionOthers, _T("BaseClock"), 7170000);
	if (ret < 1000000 || 85920000 < ret)
	{
		ret = 0;
		if (-1 > ProfileError(szSectionOthers, _T("BaseClock")))
			return FALSE;
	}
	else
		BaseClockErr = FALSE;
	BaseClock = ret - (ret % 1000);

	ret = pApp->GetProfileInt(szSectionOthers, _T("MakeLog"), 0);
	if (ret != 0 && ret != 1)
	{
		ret = 0;
		if (-1 > ProfileError(szSectionOthers, _T("MakeLog")))
			return FALSE;
	}
	else
		MakeLogErr = FALSE;
	MakeLog = ret;
	SetLogDumpDetail(MakeLog);

	static TCHAR	szSectionDirectories[] = _T("Directories");
	RomDir = pApp->GetProfileString(szSectionDirectories, _T("RomDir"), _T(""));
	CString strSaveDir = pApp->GetProfileString(szSectionDirectories, _T("SaveDir"), _T("."));
	save_dir[0] = '\0';
	strncat(save_dir, strSaveDir, MAX_PATH-1);
	int len = strlen(save_dir);
	if (save_dir[len-1]=='\\')
		save_dir[len-1] = '\0';
	TempDir = pApp->GetProfileString(szSectionDirectories, _T("TempDir"), _T(""));

#define LOAD_PROFILE_MODE(szSection, no, defval) \
	str = pApp->GetProfileString(szSection, "Mode"#no, defval); \
	if (str != "") \
	{ \
		p = str.GetBuffer(str.GetLength()); \
		p = strtok(p, "x "); \
		if (p != NULL) \
		{ \
			mode[no].width = atoi(p); \
			p = strtok(NULL, ", "); \
			if (p != NULL) \
			{ \
				mode[no].height = atoi(p); \
				p = strtok(NULL, " "); \
				if (p != NULL) \
					mode[no].zoom = atoi(p); \
			} \
		} \
		str.ReleaseBuffer(-1); \
		if (p==NULL || mode[no].width==0 || mode[no].height==0 || \
			mode[no].zoom!=1 && mode[no].zoom!=2) \
		{ \
			mode[no].width = 640; \
			mode[no].height = 480; \
			mode[no].zoom = 1; \
			if (-1 > ProfileError(szSection, "Mode"#no)) \
				return FALSE; \
		} \
		else \
		{ \
			numMode = no+1; \
			Mode##no##Err = FALSE; \
		} \
	} \
	else \
		Mode##no##Err = FALSE;
	static TCHAR	szSectionMode[] = "ScreenMode";
	LOAD_PROFILE_MODE(szSectionMode, 0, "320x240,1");
	LOAD_PROFILE_MODE(szSectionMode, 1, "640x480,2");
	LOAD_PROFILE_MODE(szSectionMode, 2, "");
	LOAD_PROFILE_MODE(szSectionMode, 3, "");

	return TRUE;
}

int CMainFrame::CheckJoyRange(int code, LPCTSTR szSection, LPCTSTR szEntry)
{
	if (0 <= code && code < 32)
		return 0;
	else
		return ProfileError(szSection, szEntry);
}

int CMainFrame::ProfileError(LPCTSTR szSection, LPCTSTR szEntry)
{
	TCHAR	szBuf[128];

	wsprintf(szBuf, _T(" [%s] ̴ %s ɴװ܂"), szSection, szEntry);
	if (IDCANCEL == MessageBox(szBuf, _T("ini̧قɴװ"), MB_ICONEXCLAMATION | MB_OKCANCEL))
		return -2;
	return -1;
}

typedef struct tagKEY_STRING
{
	TCHAR	szKeyString[16];
	int		keycode;
} KEY_STRING;

static KEY_STRING	ks[] =
{
	_T("TAB"), VK_TAB,
	_T("ENTER"), VK_RETURN,
	_T("SHIFT"), VK_SHIFT,
	_T("CONTROL"), VK_CONTROL,
	_T("ALT"), VK_MENU,
	_T("SPACE"), VK_SPACE,
	_T("PAGEUP"), VK_PRIOR,
	_T("PAGEDOWN"), VK_NEXT,
	_T("END"), VK_END,
	_T("HOME"), VK_HOME,
	_T("LEFT"), VK_LEFT,
	_T("UP"), VK_UP,
	_T("RIGHT"), VK_RIGHT,
	_T("DOWN"), VK_DOWN,
	_T("INSERT"), VK_INSERT,
	_T("DELETE"), VK_DELETE,
	_T("NUM0"), VK_NUMPAD0,
	_T("NUM1"), VK_NUMPAD1,
	_T("NUM2"), VK_NUMPAD2,
	_T("NUM3"), VK_NUMPAD3,
	_T("NUM4"), VK_NUMPAD4,
	_T("NUM5"), VK_NUMPAD5,
	_T("NUM6"), VK_NUMPAD6,
	_T("NUM7"), VK_NUMPAD7,
	_T("NUM8"), VK_NUMPAD8,
	_T("NUM9"), VK_NUMPAD9,
	_T("NUM*"), VK_MULTIPLY,
	_T("NUM+"), VK_ADD,
	_T("NUM-"), VK_SUBTRACT,
	_T("NUM/"), VK_DIVIDE,
	_T(","), 0xBC,
	_T("."), 0xBE,
	_T("/"), 0xBF,
	_T(";"), 0xBB,
	_T(":"), 0xBA,
	_T("]"), 0xDD,
	_T("@"), 0xC0,
	_T("["), 0xDB,
	_T("-"), 0xBD,
	_T("^"), 0xDE,
	_T("\\"), 0xDC,
};
static const int KEY_STRING_NUM = sizeof(ks)/sizeof(KEY_STRING);

int CMainFrame::CheckKeyString(LPCTSTR szCode, LPCTSTR szSection, LPCTSTR szEntry)
{
	int		i;

	if (szCode[0] == _T('\0'))
		goto KEYSTRING_ERROR_MESSAGE;
	if (szCode[1] == _T('\0'))
	{
		if ('A' <= szCode[0] && szCode[0] <= 'Z')
			return szCode[0];
	}
	for (i = 0; i < KEY_STRING_NUM; i++)
	{
		if (0 == _tcscmp(ks[i].szKeyString, szCode))
			return ks[i].keycode;
	}
	goto KEYSTRING_ERROR_MESSAGE;

KEYSTRING_ERROR_MESSAGE:
	return ProfileError(szSection, szEntry);
}

void CMainFrame::SaveProfile()
{
	TCHAR	szBuf[256];
	CWinApp	*pApp = AfxGetApp();

	static TCHAR	szSectionJoy[] = _T("Joystick");
	if (!ksJoy1Err)	pApp->WriteProfileInt(szSectionJoy, _T("1"), ksJoy1);
	if (!ksJoy2Err)	pApp->WriteProfileInt(szSectionJoy, _T("2"), ksJoy2);
	if (!ksJoy11Err)	pApp->WriteProfileInt(szSectionJoy, _T("11"), ksJoy11);
	if (!ksJoy22Err)	pApp->WriteProfileInt(szSectionJoy, _T("22"), ksJoy22);
	if (!ksJoyRunErr)	pApp->WriteProfileInt(szSectionJoy, _T("Run"), ksJoyRun);
	if (!ksJoySelErr)	pApp->WriteProfileInt(szSectionJoy, _T("Sel"), ksJoySel);

#define SAVE_PROFILE_KEY(key, szSection, szEntry)\
		{\
			if (!key##Err)\
			{\
				GetKeyString(szKeyString, key);\
				pApp->WriteProfileString(szSection, szEntry, szKeyString);\
			}\
		}
	TCHAR	szKeyString[16];
	static TCHAR	szSectionKey[] = _T("Keyboard");
	SAVE_PROFILE_KEY(ksKey1, szSectionKey, _T("1"));
	SAVE_PROFILE_KEY(ksKey2, szSectionKey, _T("2"));
	SAVE_PROFILE_KEY(ksKey11, szSectionKey, _T("11"));
	SAVE_PROFILE_KEY(ksKey22, szSectionKey, _T("22"));
	SAVE_PROFILE_KEY(ksKeyRun, szSectionKey, _T("Run"));
	SAVE_PROFILE_KEY(ksKeySel, szSectionKey, _T("Sel"));
	SAVE_PROFILE_KEY(ksKeyDown, szSectionKey, _T("Down"));
	SAVE_PROFILE_KEY(ksKeyUp, szSectionKey, _T("Up"));
	SAVE_PROFILE_KEY(ksKeyLeft, szSectionKey, _T("Left"));
	SAVE_PROFILE_KEY(ksKeyRight, szSectionKey, _T("Right"));

	static TCHAR	szSectionSound[] = _T("Sound");
	if (!snd_bSoundErr)	pApp->WriteProfileInt(szSectionSound, _T("Sound"), snd_bSound);
	if (!snd_dwSampleRateErr)	pApp->WriteProfileInt(szSectionSound, _T("SampleRate"), snd_dwSampleRate);
//	if (!snd_dwBitsErr)	pApp->WriteProfileInt(szSectionSound, _T("Bits"), snd_dwBits);
	if (!snd_dwChannelsErr)	pApp->WriteProfileInt(szSectionSound, _T("Channels"), snd_dwChannels);
	if (!snd_CoopModeErr)	pApp->WriteProfileInt(szSectionSound, _T("CoopMode"), snd_CoopMode);
	if (!snd_LatencyErr)	pApp->WriteProfileInt(szSectionSound, _T("Latency"), snd_Latency);

	static TCHAR	szSectionOthers[] = _T("Others");
	if (!bShowFpsErr)	pApp->WriteProfileInt(szSectionOthers, _T("ShowFPS"), bShowFps);
	if (!bAutoFrameSkipErr)	pApp->WriteProfileInt(szSectionOthers, _T("AutoFrameSkip"), bAutoFrameSkip);
	if (!UPeriodErr)	pApp->WriteProfileInt(szSectionOthers, _T("FrameSkipCount"), UPeriod);
	if (!BaseClockErr)	pApp->WriteProfileInt(szSectionOthers, _T("BaseClock"), BaseClock);
	if (!MakeLogErr)	pApp->WriteProfileInt(szSectionOthers, _T("MakeLog"), MakeLog);

	static TCHAR	szSectionDirectories[] = _T("Directories");
	pApp->WriteProfileString(szSectionDirectories, _T("RomDir"), RomDir);
	pApp->WriteProfileString(szSectionDirectories, _T("SaveDir"), save_dir);
	pApp->WriteProfileString(szSectionDirectories, _T("TempDir"), TempDir);

#define SAVE_PROFILE_MODE(szSection, no) \
	if (!Mode##no##Err) \
	{ \
		if (no < numMode) \
		{ \
			wsprintf(szBuf, "%dx%d,%d", mode[no].width, mode[no].height, mode[no].zoom); \
			pApp->WriteProfileString(szSection, "Mode"#no, szBuf); \
		} \
	}
	static TCHAR	szSectionMode[] = _T("ScreenMode");
	SAVE_PROFILE_MODE(szSectionMode, 0);
	SAVE_PROFILE_MODE(szSectionMode, 1);
	SAVE_PROFILE_MODE(szSectionMode, 2);
	SAVE_PROFILE_MODE(szSectionMode, 3);
}

void CMainFrame::GetKeyString(LPTSTR szKeyString, int key)
{
	int		i;

	if ('A' <= key && key <= 'Z')
	{
		szKeyString[0] = key;
		szKeyString[1] = _T('\0');
		return;
	}

	for (i = 0; i < KEY_STRING_NUM; i++)
	{
		if (key == ks[i].keycode)
		{
			_tcscpy(szKeyString, ks[i].szKeyString);
			return;
		}
	}
	ASSERT(FALSE);
}

LRESULT CMainFrame::OnDDInitialize(WPARAM wParam, LPARAM lParam)
{
	hwnd = m_hWnd;

	if (!InitDDraw() || !InitSurfaces(FALSE))
		return FALSE;

	if (m_pCmdLine != NULL)
	{
		m_pMainThread = AfxBeginThread(InvokeMainLoop, this);
		AttachThreadInput(m_pMainThread->m_nThreadID, GetCurrentThreadId(), TRUE);
	}

	return 0;
}

UINT CMainFrame::InvokeMainLoop(LPVOID pParam)
{
	char	*argv[4];
	int		iRet;
	char	backmemname[MAX_PATH];
	char	*yen;

	GetModuleFileName(NULL, backmemname, sizeof(backmemname));
	yen = strrchr(backmemname, '\\');
	if (yen == NULL)
		yen = backmemname;
	strcpy(yen, "\\backup.dat");
	argv[0] = "";
	argv[1] = ((CMainFrame *)pParam)->m_pCmdLine;
	argv[2] = backmemname;
	argv[3] = "\0";
	iRet = main_loop(3, argv);
	((CMainFrame *)pParam)->PostMessage(WM_CLOSE, 0, 0);
	return iRet;
}

void CMainFrame::OnDestroy() 
{
	if (m_strExtractedFileName != "")
	{
		DeleteFile(m_strExtractedFileName);
		m_strExtractedFileName = "";
	}

	if (hEventNotify)
	{
		dwEvent = EV_STOP;
		SetEvent(hEventNotify);
		WaitForSingleObject(m_pMainThread->m_hThread, INFINITE);
	}
	if (m_hPaletteOld)
	{
		HDC hdc = ::GetDC(m_hWnd);
		SelectPalette(hdc, m_hPaletteOld, FALSE);
		::ReleaseDC(hwnd, hdc);
	}

	CFrameWnd::OnDestroy();

	ReleaseSurfaces();
	ReleaseDDraw();
	ShowCursor(TRUE);
	SaveProfile();
	return;
}

void CMainFrame::OnActivateApp(BOOL bActive, HTASK hTask) 
{
	CFrameWnd::OnActivateApp(bActive, hTask);
	
	bActiveApp = bActive;
}

void CMainFrame::OnMove(int x, int y) 
{
	CFrameWnd::OnMove(x, y);

	OnMoveWindow(x, y);
}

BOOL CMainFrame::OnQueryNewPalette() 
{
	if (hPaletteApp)
	{
		TRACE0("Palette changed\n");
		HDC hdc = ::GetDC(m_hWnd);
		if (m_hPaletteOld)
			SelectPalette(hdc, m_hPaletteOld, FALSE);
		m_hPaletteOld = SelectPalette(hdc, hPaletteApp, FALSE);
		RealizePalette(hdc);
		::ReleaseDC(m_hWnd, hdc);
		return 1;
	}

	return CFrameWnd::OnQueryNewPalette();
}

void CMainFrame::OnPaletteChanged(CWnd* pFocusWnd) 
{
	CFrameWnd::OnPaletteChanged(pFocusWnd);

	if (hPaletteApp && pFocusWnd != this)
	{
		TRACE("Palette Changed2\n");
		OnQueryNewPalette();
	}
}

void CMainFrame::OnInitMenu(CMenu* pMenu) 
{
	CFrameWnd::OnInitMenu(pMenu);

	
}

void CMainFrame::OnExit() 
{
	PostMessage(WM_CLOSE, 0, 0);
}

void CMainFrame::OnFullScreen() 
{
	if (hEventNotify)
	{
		dwEvent = EV_FULLSCREEN;
		SetEvent(hEventNotify);
	}
}

void CMainFrame::OnLoad() 
{
	if (hEventNotify)
	{
		dwEvent = EV_LOAD;
		SetEvent(hEventNotify);
	}
}

void CMainFrame::OnSave() 
{
	if (hEventNotify)
	{
		dwEvent = EV_SAVE;
		SetEvent(hEventNotify);
	}
}

void CMainFrame::OnZoom1() 
{
	if (hEventNotify)
	{
		dwEvent = EV_ZOOM;
		SetEvent(hEventNotify);
	}
}
/*
void CMainFrame::OnZoom2() 
{
	if (hEventNotify)
	{
		dwEvent = EV_ZOOM2;
		SetEvent(hEventNotify);
	}
}
*/
void CMainFrame::OnReset() 
{
	if (hEventNotify)
	{
		dwEvent = EV_RESET;
		SetEvent(hEventNotify);
	}
}

LRESULT CMainFrame::OnChangeWindowMode(WPARAM wParam, LPARAM lParam)
{
	ChangeWindowMode();
	SetEvent(hEventEndCommand);
	return 0;
}

void CMainFrame::OnOpen() 
{
	if (RomDir != "")
		SetCurrentDirectory(RomDir);
	const char *szFilter = "pce ̧ (*.pce)|*.pce|ׂĂ̧ (*.*)|*.*||";
	BOOL bUseArchiver = FALSE;

	if (LoadArchiver())
	{
		szFilter = "pce ̧ (*.pce;*.zip)|*.pce;*.zip|pce romҰ (*.pce)|*.pce|kҰ (*.zip)|*.zip|ׂĂ̧ (*.*)|*.*||";
		bUseArchiver = TRUE;
	}
	CFileDialog	dlg(TRUE, NULL, NULL, OFN_HIDEREADONLY, szFilter);
	if (bUseArchiver)
		FreeArchiver();

	if (IDOK == dlg.DoModal())
		LoadPceFile(dlg.GetPathName());
}

BOOL CMainFrame::LoadPceFile(const char *load_path)
{
	static char	szFileName[MAX_PATH];
	char	szBuf[MAX_PATH];
	char	drive[_MAX_DRIVE];
	char	dir[_MAX_DIR];
	char	filename[_MAX_FNAME];
	char	ext[_MAX_EXT];
	const char	*temp_p;

	if (m_strExtractedFileName != "")
	{
		DeleteFile(m_strExtractedFileName);
		m_strExtractedFileName = "";
	}

	if (NULL == _fullpath(szFileName, load_path, sizeof(szFileName)))
		return FALSE;
	m_pCmdLine = szFileName;
	_splitpath(szFileName, drive, dir, filename, ext);

	RomDir = CString(drive) + dir;
	if (RomDir.Right(1) == "\\")
		RomDir = RomDir.Left(RomDir.GetLength()-1);

	if (0 == strcmp(ext, ".zip"))
	{
		if (!LoadArchiver())
			return FALSE;
		if (TempDir == "")
			temp_p = RomDir;
		else
			temp_p = TempDir;
		if (NULL == _fullpath(szBuf, temp_p, sizeof(szBuf)))
		{
			FreeArchiver();
			return FALSE;
		}
		if (!ExtractArchive(szFileName, szBuf))
		{
			FreeArchiver();
			MessageBox("̧ق̉𓀂Ɏs܂", "װ", MB_OK | MB_ICONEXCLAMATION);
			return FALSE;
		}
		m_strExtractedFileName = szBuf;
		strcpy(szFileName, szBuf);
		FreeArchiver();
	}

	if (m_pMainThread)
	{
		if (hEventNotify)
		{
			dwEvent = EV_CARTLOAD;
			pCartName = m_pCmdLine;
			SetEvent(hEventNotify);
		}
	}
	else
	{
		m_pMainThread = AfxBeginThread(InvokeMainLoop, this);
		AttachThreadInput(m_pMainThread->m_nThreadID, GetCurrentThreadId(), TRUE);
	}
	return TRUE;
}

void CMainFrame::OnAbout() 
{
	CAboutDlg	dlg;
	dlg.DoModal();
}
