#include "stdafx.h"

typedef int (WINAPI *LPUNZIPPROC)(const HWND hWnd,LPCSTR szCmdLine,LPSTR szOutput,const DWORD dwSize);
typedef WORD (WINAPI *LPUNZIPGETVERSIONPROC)(VOID);
typedef BOOL (WINAPI *LPUNZIPGETRUNNINGPROC)(VOID);
LPUNZIPPROC				UnZip = NULL;
LPUNZIPGETVERSIONPROC	UnZipGetVersion = NULL;
LPUNZIPGETRUNNINGPROC	UnZipGetRunning = NULL;
HINSTANCE	hMod = NULL;

BOOL LoadArchiver()
{
	hMod = LoadLibrary("unzip32.dll");
	if (hMod != NULL)
	{
		UnZip = (LPUNZIPPROC)GetProcAddress(hMod, "UnZip");
		UnZipGetVersion = (LPUNZIPGETVERSIONPROC)GetProcAddress(hMod, "UnZipGetVersion");
		UnZipGetRunning = (LPUNZIPGETRUNNINGPROC)GetProcAddress(hMod, "UnZipGetRunning");
		if (UnZip && UnZipGetVersion && UnZipGetRunning &&
			UnZipGetVersion() >= 75 && !UnZipGetRunning())
		{
			return TRUE;
		}
		else
		{
			FreeLibrary(hMod);
			hMod = NULL;
		}
	}
	return FALSE;
}

static char *strristr(const char *str1, const char *str2)
{
	int		len1, len2;
	int		i, j;

	len1 = strlen(str1);
	len2 = strlen(str2);
	for (i = len1-1; i >= len2-1; i--)
	{
		for (j = 0; j < len2; j++)
		{
			if (tolower(str1[i-j]) != tolower(str2[len2-1-j]))
				break;
		}
		if (j == len2)
			return (char *)&str1[i-len2+1];
	}
	return NULL;
}

char *strrpbrk(const char *str1, const char *str2)
{
	int		len1;
	int		i, j;

	len1 = strlen(str1);
	for (i = len1-1; i >= 0; i--)
	{
		for (j = 0; str2[j]; j++)
		{
			if (str1[i] == str2[j])
				return (char *)&str1[i];
		}
	}
	return NULL;
}

BOOL ExtractArchive(const char *archive_filename, char *extract_dir)
{
	char	command_line[1024];
	char	output_string[1024];
	char	temp_output[512];
	char	*p;
	char	*pce_filename;
	char	*pce_p;
	int		len_extract_dir;

	wsprintf(command_line, "-l --x -j -n -q %s", archive_filename);
	if (0x8000 <= UnZip(NULL, command_line, output_string, sizeof(output_string)))
		return FALSE;
	output_string[sizeof(output_string)-1] = '\0';

	pce_filename = strtok(output_string, "\r\n");
	while (pce_filename != NULL)
	{
		pce_p = strristr(pce_filename, ".pce ");
		if (pce_p != NULL)
		{
			pce_p[4] = '\0';	// replace ' ' to '\0'
			p = strrchr(pce_filename, ' ');
			if (p == NULL)
				TRACE0("ExtractArchive - cannot find space chr.\n");
			else
			{
				pce_filename = p+1;
				len_extract_dir = strlen(extract_dir);
				if (extract_dir[len_extract_dir-1] != '\\')
					strcat(extract_dir, "\\");
				wsprintf(command_line, "-x -j --i -n -q %s %s %s", archive_filename, extract_dir, pce_filename);
				if (0x8000 <= UnZip(NULL, command_line, temp_output, sizeof(temp_output)))
					return FALSE;
				if (NULL != strristr(temp_output, "skipping"))
					return FALSE;
				p = strrpbrk(pce_filename, "/\\");
				if (p != NULL)
					pce_filename = p+1;
				strcat(extract_dir, pce_filename);
				return TRUE;
			}
		}
		pce_filename = strtok(NULL, "\r\n");
	}

	return FALSE;
}

void FreeArchiver()
{
	if (hMod != NULL)
		FreeLibrary(hMod);
	hMod = NULL;
	UnZip = NULL;
	UnZipGetVersion = NULL;
	UnZipGetRunning = NULL;
}
