// log.cpp

#include "stdafx.h"
#include <io.h>

static BOOL g_bLogMaked = FALSE;
static TCHAR g_szLogFileName[MAX_PATH];
static BOOL g_bDetail = TRUE;//FALSE;

static void DumpMessage(LPCTSTR szMsg, va_list arg);
static void PrepareLogFile(void);

void SetLogDumpDetail(BOOL bDetail)
{
	g_bDetail = bDetail;
}

void LogDumpDetail(LPCTSTR szMsg, ...)
{
	va_list	arg;

	va_start(arg, szMsg);

	if (g_bDetail)
		DumpMessage(szMsg, arg);

	va_end(arg);
}

void LogDump(LPCTSTR szMsg, ...)
{
	va_list	arg;

	va_start(arg, szMsg);

	DumpMessage(szMsg, arg);

	va_end(arg);
}

void DumpMessage(LPCTSTR szMsg, va_list arg)
{
	FILE	*fp;

	if (!g_bLogMaked)
	{
		PrepareLogFile();
		g_bLogMaked = TRUE;
	}
	fp = _tfopen(g_szLogFileName, _T("a+"));
	if (fp == NULL)
	{
		TRACE(_T("cannot create log file [%s]\n"), g_szLogFileName);
		return;
	}
	_vftprintf(fp, szMsg, arg);
	fclose(fp);

#ifdef _DEBUG
	TCHAR	szBuf[256];
	_vstprintf(szBuf, szMsg, arg);
	TRACE0(szBuf);
#endif // _DEBUG
}

static void PrepareLogFile(void)
{
	TCHAR	szBuf[MAX_PATH];
	TCHAR	*pcYen;

	GetModuleFileName(NULL, szBuf, sizeof(szBuf));

	pcYen = _tcsrchr(szBuf, _T('\\'));
	if (pcYen == NULL)
		_tcscpy(g_szLogFileName, _T("\\"));
	else
	{
		_tcsncpy(g_szLogFileName, szBuf, pcYen-szBuf+1);
		g_szLogFileName[pcYen-szBuf+1] = _T('\0');
	}
	_tcscpy(szBuf, g_szLogFileName);
	_tcscat(g_szLogFileName, _T("xpce.log"));
	_tcscat(szBuf, _T("xpce.log.bak"));

	if (0 == _taccess(g_szLogFileName, 0x00))
	{
		if (0 == _taccess(szBuf, 0x00))
			DeleteFile(szBuf);
		MoveFile(g_szLogFileName, szBuf);
	}
}
