#include	"stdafx.h"
#include	<stdlib.h>
#include	<limits.h>
#include	<io.h>
#include	<direct.h>
#include	<math.h>
#include	<mmsystem.h>
#include	"m6502.h"
#include	"pce.h"
#include	"dd.h"
#ifdef USE_JOYSTICK
#include	"di.h"
#endif // USE_JOYSTICK
#include	"info.h"
#include	"log.h"

#ifdef SOUND
#include "sound.h"
#endif

#ifdef SOUND
//int UseSound = 1;
//int SndSwitch = 0x0F;
//int SndVolume = 200;
#endif

#define WM_CHANGEWINDOWMODE	(WM_APP + 5)

unsigned char *XBuf;
int Verbose = 1;
int Debug=1;
int vmode=0;
//HANDLE	hEventHsyncTimer = NULL;
HANDLE	hEventNotify = NULL;
HANDLE	hEventEndCommand = NULL;
DWORD	dwEvent = 0;
char	*pCartName = NULL;

BOOL SupportMMX = FALSE;
BOOL bEraseBackground = TRUE;

//static UINT uHsyncTimerID = 0;
//static UINT uTimerID = 0;

extern int ksJoy1;
extern int ksJoy2;
extern int ksJoy11;
extern int ksJoy22;
extern int ksJoyRun;
extern int ksJoySel;
extern int ksKey1;
extern int ksKey2;
extern int ksKey11;
extern int ksKey22;
extern int ksKeyRun;
extern int ksKeySel;
extern int ksKeyDown;
extern int ksKeyUp;
extern int ksKeyLeft;
extern int ksKeyRight;

extern BOOL snd_bSound;

extern BOOL bShowFps;
extern int bAutoFrameSkip;

extern char save_dir[];

extern int UPeriod;
extern int scanlines_per_frame;
extern IO io;
extern M6502 M;
extern byte cart_reload;
extern byte populus;

#define EV_STOP			0x0001
#define EV_SAVE			0x0002
#define EV_LOAD			0x0004
#define EV_FULLSCREEN	0x0008
#define EV_ZOOM			0x0010
//#define EV_ZOOM2		0x0020
#define EV_RESET		0x0040
#define EV_CARTLOAD		0x0080
#define EV_DOWNSKIPRATE	0x0100
#define EV_UPSKIPRATE	0x0200
#define EV_AUTOFRAMESKIP	0x0400

int InitMachine(void);
void TrashMachine(void);
void PutImage(int X, int Y, int W, int H);
int JoySticks(void);
void ResetPCE(M6502 *M);

#if 0
void DrawVram(void)
{
	HRESULT	ddret;
	DDSURFACEDESC	ddsd;
	BYTE	*lpDDMemory;
	int		i;
	RECT	rcDest, rcSrc;
	extern BYTE *VRAM;

	memset(&ddsd, 0, sizeof(DDSURFACEDESC));
	ddsd.dwSize = sizeof(ddsd);
	ddret = lpSurface->Lock(NULL, &ddsd, 0, NULL);
	if (FAILED(ddret))
	{
		TRACE("Lock Failed\n");
		return;
	}

	lpDDMemory = (BYTE *)ddsd.lpSurface;
	BYTE *C = VRAM;// + 0x1700*2;
	BYTE *p = lpDDMemory;
	for (i = 0; i < (int)ddsd.dwHeight; i++)
	{
		memset(p, 0, ddsd.dwWidth);
		p += ddsd.lPitch;
	}
	p = lpDDMemory;
	for (i = 0; i < 80; i++)
	{
		BYTE *py = p;
		for (int j = 0; j < 40; j++)
		{
			BYTE *px = p;
			for (int k = 0; k < 8; k++)
			{
				BYTE c= *C++;
				for (int l = 0; l < 8; l++)
				{
					*p++ = (c & 0x80) ? 255 : 0;
					c <<= 1;
				}
				c= *C++;
				for (l = 0; l < 8; l++)
				{
					*p++ = (c & 0x80) ? 255 : 0;
					c <<= 1;
				}
				p += ddsd.lPitch - 16;
			}
			p = px + 16;
		}
		p = py + ddsd.lPitch*8;
	}

	lpSurface->Unlock(NULL);
	TRACE("width = %d, height = %d\n", ddsd.dwWidth, ddsd.dwHeight);

	rcDest.left = 640;
	rcDest.top = 0;
	rcDest.right = 1279;
	rcDest.bottom = 639;

	rcSrc.left = 0;
	rcSrc.top = 0;
	rcSrc.right = 639;
	rcSrc.bottom = 639;

	ddret = lpPrimarySurface->Blt(&rcDest, lpSurface, &rcSrc, DDBLT_WAIT, NULL);

	FILE *fp = fopen("batdump.dat", "wb");
	if (fp == NULL)
		TRACE("can't open file\n");
	else
	{
		fwrite(VRAM, 1, 0x10000, fp);
		fclose(fp);
	}
}
#endif

void PutImage(int X,int Y,int W,int H)
{
	HRESULT	ddret;
	DDSURFACEDESC	ddsd;
	BYTE	*lpDDMemory;
	BYTE	*lpDist, *lpSrc;
	DWORD	dwDistX, dwDistY;
	int		i;
	static RECT	rcSrc;
	DDBLTFX	ddbfx;

	static DWORD RShift, GShift, BShift;
	static DWORD dwBitCountOld = 0;
	static DWORD PalTable[256];

	static DWORD dwEraseCount = 0;
	static oldW, oldH;

#if 0
	if (GetKeyState('E') & 0x80)
	{
		DrawVram();
		Sleep(5000);
	}
#endif

	static DWORD	dwTime, dwNoDrawCount, dwTick, dwTickOld;

//	dwTime++;
//	if (dwTime >= 3)
//	{
//		dwTime = 0;
//		return;
//	}
//	if (dwFrameCount >= 30)
//	{
//		TRACE("FrameRate = %d\n", dwFrameDraw*60/dwFrameCount);
//		dwFrameCount = 0;
//		dwFrameDraw = 0;
//	}
	if (bAutoFrameSkip)
	{
		dwTime = timeGetTime();
		while ((int)(dwTime - dwTick) < 500*(UPeriod + 1)/60 && dwNoDrawCount==0)
		{
			Sleep(1);
			dwTime = timeGetTime();
		}
		if ((int)(dwTime - dwTick) >= (1350*(UPeriod + 1)/60))
		{
//			TRACE("%d\n", dwTime - dwTick);
			dwNoDrawCount++;
			if ((int)dwNoDrawCount <= 4/(UPeriod + 1))
			{
				dwTick = dwTime - (DWORD)fmod(dwTime, (1000.0/60.0*(UPeriod + 1)));
				return;
			}
		}
		dwNoDrawCount = 0;
		dwTick = dwTime - (DWORD)fmod(dwTime, (1000.0/60.0*(UPeriod + 1)));
		while (dwTick == dwTickOld)
		{
			dwTime += 1000*(UPeriod + 1)/60;
			dwTick = dwTime - (DWORD)fmod(dwTime, (1000.0/60.0*(UPeriod + 1)));
//			dwTick += 1000*(UPeriod + 1)/60;
		}
//		TRACE("%d\n", dwTick - dwTickOld);
		dwTickOld = dwTick;
	}

	if (bFullScreen && !bActiveApp)
		return;

	if (W == 0)
		return;

	static DWORD	dwFpsTime, dwFpsTimeOld;
	static int		iFrame;
	static int		fps;

	dwFpsTime = timeGetTime();
	iFrame++;
	DWORD	dwSpan = dwFpsTime - dwFpsTimeOld;
	if (dwSpan > 500)
	{
		fps = (iFrame*1000 + dwSpan/2)/dwSpan;
		iFrame = 0;
		dwFpsTimeOld = dwFpsTime;
	}
	if (bShowFps)
		SetInfoFps(fps);

	if (lpPrimarySurface->IsLost() == DDERR_SURFACELOST ||
		lpBackSurface->IsLost() == DDERR_SURFACELOST)
	{
		RestoreSurfaces();
	}

	if (H != oldH || W != oldW || bEraseBackground)
	{
		TRACE("W = %d, H = %d\n", W, H);
		oldH = H;
		oldW = W;
		dwEraseCount++;
		TRACE("dwEraseCount = %d\n", dwEraseCount);
		if (dwEraseCount >= 2)
		{
			dwEraseCount = 0;
			bEraseBackground = FALSE;
		}
		ddbfx.dwSize = sizeof(ddbfx);
		ddbfx.dwFillColor = 0;
		ddret = lpBackSurface->Blt(NULL, NULL, NULL, DDBLT_COLORFILL | DDBLT_DDFX | DDBLT_WAIT, &ddbfx);
		if (FAILED(ddret))
			TRACE("Blt failed\n");
	}

	memset(&ddsd, 0, sizeof(DDSURFACEDESC));
	ddsd.dwSize = sizeof(ddsd);
	ddret = lpBackSurface->Lock(NULL, &ddsd, DDLOCK_WAIT, NULL);
	if (FAILED(ddret))
	{
//		TRACE0("Locks\n");
		LogDumpDetail("Lock failed,code=%08X\n", ddret);
		return;
	}

	lpDDMemory = (BYTE *)ddsd.lpSurface;

/*	if (H != oldH || W != oldW)
	{
		BYTE *d = lpDDMemory;
		DWORD c;
		if (ddsd.ddpfPixelFormat.dwFlags & DDPF_RGB)
			c = ddsd.dwWidth*ddsd.ddpfPixelFormat.dwRGBBitCount/8/4;
		else if (ddsd.ddpfPixelFormat.dwFlags & DDPF_PALETTEINDEXEDTO8)
			c = ddsd.dwWidth*8/8/4;
		else
			return;
		for (i = 0; i < (int)ddsd.dwHeight; i++)
		{
			__asm {
				push	edi
				mov		ax,ds
				mov		es,ax
				mov		edi,d
				mov		ecx,c
				xor		eax,eax
			rep	stosd
				pop		edi
			}
			d += ddsd.lPitch;
		}
	}
*/
	if (ddsd.ddpfPixelFormat.dwFlags & DDPF_RGB)
	{
		DWORD t;

		if (dwBitCountOld != ddsd.ddpfPixelFormat.dwRGBBitCount)
		{
			dwBitCountOld = ddsd.ddpfPixelFormat.dwRGBBitCount;
			t = ddsd.ddpfPixelFormat.dwRBitMask;
			for (i = 0; i < 32; i++)
			{
				t >>= 1;
				if (t == 0)
				{
					RShift = i - 2;
					break;
				}
			}
			t = ddsd.ddpfPixelFormat.dwGBitMask;
			for (i = 0; i < 32; i++)
			{
				t >>= 1;
				if (t == 0)
				{
					GShift = i - 2;
					break;
				}
			}
			t = ddsd.ddpfPixelFormat.dwBBitMask;
			for (i = 0; i < 32; i++)
			{
				t >>= 1;
				if (t == 0)
				{
					BShift = i - 1;
					break;
				}
			}
			for (i = 0; i < 256; i++)
			{
				PalTable[i] = (((i>>2)&7)<<RShift) & ddsd.ddpfPixelFormat.dwRBitMask;
				PalTable[i] |= ((i>>5)<<GShift) & ddsd.ddpfPixelFormat.dwGBitMask;
				PalTable[i] |= ((i&3)<<BShift) & ddsd.ddpfPixelFormat.dwBBitMask;
			}
//				TRACE("RMask = %X\nGMask = %X\nBMask = %X\n", ddsd.ddpfPixelFormat.dwRBitMask, ddsd.ddpfPixelFormat.dwGBitMask, ddsd.ddpfPixelFormat.dwBBitMask);
//				TRACE("RShift = %X\nGShift = %X\nBShift = %X\n", RShift, GShift, BShift);
		}
	}

	if (bFullScreen && mode[curMode].zoom == 1 ||
		!bFullScreen && (curMode&1)==0)
	{
		dwDistX = (long)(ddsd.dwWidth - W)/2;
		if ((long)dwDistX < 0)
		{
			X += (long)(W - ddsd.dwWidth)/2;
			W = ddsd.dwWidth;
			dwDistX = 0;
		}
		dwDistY = (long)(ddsd.dwHeight - H)/2;
		if ((long)dwDistY < 0)
		{
			Y += (long)(H - ddsd.dwHeight)/2;
			H = ddsd.dwHeight;
			dwDistY = 0;
		}
		lpDist = lpDDMemory + dwDistY*ddsd.lPitch;

		lpSrc = XBuf + Y*WIDTH + X;
		if (ddsd.ddpfPixelFormat.dwFlags & DDPF_PALETTEINDEXED8)
		{
			lpDist += dwDistX;
			if (SupportMMX)
			{
				for (i = 0; i < H; i++)
				{
					__asm {
						push	edi
						push	esi
						mov		edi,lpDist
						mov		esi,lpSrc
						mov		ecx,W
						shr		ecx,3
						mov		edx,8
					lp0_1:
						movq	mm0,[esi]
						movq	[edi],mm0
						add		esi,edx
						add		edi,edx
						loop	lp0_1
					}
					lpDist += ddsd.lPitch;
					lpSrc += WIDTH;
				}
				__asm {
					emms
				}
			}
			else
			{
				for (i = 0; i < H; i++)
				{
					//memcpy(lpDist, lpSrc, W);
					__asm {
						push	edi
						push	esi
						mov		ax,ds
						mov		es,ax
						mov		edi,lpDist
						mov		esi,lpSrc
						mov		ecx,W
						shr		ecx,2
					rep	movsd
						pop		esi
						pop		edi
					}
					lpDist += ddsd.lPitch;
					lpSrc += WIDTH;
				}
			}
		}
		else if (ddsd.ddpfPixelFormat.dwFlags & DDPF_RGB)
		{
			lpDist += (dwDistX&~1)*ddsd.ddpfPixelFormat.dwRGBBitCount/8;
			for (i = 0; i < H; i++)
			{
				BYTE	*d, *s;
				DWORD	l;
				int		j;

				d = lpDist;
				s = lpSrc;
				switch (ddsd.ddpfPixelFormat.dwRGBBitCount/8)
				{
				case 2:
					for (j = 0; j < W; j++)
					{
						*((WORD *)d) = (WORD)PalTable[*s++];
						d += 2;
					}
					break;

				case 3:
					__asm {
						push	esi
						push	edi
						mov		ax,ds
						mov		es,ax
						mov		ecx,W
						shr		ecx,1
						mov		edi,d
						mov		esi,s
						mov		ebx,offset PalTable
					lp3:
						xor		eax,eax
						lodsb
						mov		eax,[ebx+4*eax]
						mov		edx,eax
						bswap	edx
						xor		eax,eax
						lodsb
						mov		eax,[ebx+4*eax]
						xchg	eax,edx
						mov		al,dl
						bswap	eax
						stosd
						mov		eax,edx
						shr		eax,8
						stosw
						loop	lp3
						pop		edi
						pop		esi
					}
					/*
					for (j = 0; j < W; j++)
					{
						l = PalTable[*s++];
//						*((WORD *)d) = (WORD)(l & 0xFFFF);
//						d += 2;
						*d++ = (BYTE)(l>>8);
						*d++ = (BYTE)(l>>16);
						*d++ = (BYTE)(l);
					}
					*/
					break;

				case 4:
					__asm {
						push	esi
						push	edi
						mov		ax,ds
						mov		es,ax
						mov		ecx,W
						mov		edi,d
						mov		esi,s
						mov		edx,offset PalTable
					lp1:
						xor		eax,eax
						lodsb
						mov		eax,[edx+4*eax]
						stosd
						loop	lp1
						pop		edi
						pop		esi
					}
					/*
					for (j = 0; j < W; j++)
					{
						*((DWORD *)d) = PalTable[*s++];
						d += 4;
					}
					*/
					break;

				default:
					for (j = 0; j < W; j++)
					{
						l = PalTable[*s++];
						for (int k = 0; k < (int)ddsd.ddpfPixelFormat.dwRGBBitCount/8; k++)
						{
							*d++ = (BYTE)(l&0xFF);
							l >>= 8;
						}
					}
				}
				lpDist += ddsd.lPitch;
				lpSrc += WIDTH;
			}
		}
	}
	else
	{
		dwDistX = (long)(ddsd.dwWidth - W*2)/2;
		if ((long)dwDistX < 0)
		{
			X += (W - ddsd.dwWidth/2)/2;
			W = ddsd.dwWidth/2;
			dwDistX = 0;
		}
		dwDistY = (long)(ddsd.dwHeight - H*2)/2;
		if ((long)dwDistY < 0)
		{
			Y += (H - ddsd.dwHeight/2)/2;
			H = ddsd.dwHeight/2;
			dwDistY = 0;
		}
		lpDist = lpDDMemory + dwDistY*ddsd.lPitch;

		lpSrc = XBuf + Y*WIDTH + X;
		if (ddsd.ddpfPixelFormat.dwFlags & DDPF_PALETTEINDEXED8)
		{
			lpDist += dwDistX;

			if (SupportMMX)
			{
				for (i = 0; i < H; i++)
				{
					__asm {
						push	esi
						mov		ecx,W
						shr		ecx,2
						mov		ebx,lpDist
						mov		esi,ebx
						add		esi,ddsd.lPitch
						mov		eax,lpSrc
						mov		edx,8
				lp3_1:
						movd	mm0,[eax]
						movq	mm1,mm0
						punpcklbw	mm0,mm1
						movq	[ebx],mm0
						movq	[esi],mm0
						add		ebx,edx
						add		esi,edx
						add		eax,4
						loop	lp3_1
						pop		esi
					}
					lpDist += 2*ddsd.lPitch;
					lpSrc += WIDTH;
				}
				__asm {
					emms
				}
			}
			else
			{
				for (i = 0; i < H; i++)
				{
					BYTE	*d, *d2, *s;

					d = lpDist;
					d2 = lpDist + ddsd.lPitch;
					s = lpSrc;
					__asm {
						push	esi
						push	edi
						mov		ax,ds
						mov		es,ax
						mov		ecx,W
						mov		esi,s
						mov		edi,d
						mov		ebx,d2
				lp2:	lodsb
						mov		ah,al
						stosw
						mov		[ebx],ax
						add		ebx,2
						loop	lp2
						pop		edi
						pop		esi
					}
					/*
					for (int j = 0; j < W; j++)
					{
						*d++ = *s;
						*d++ = *s;
						*d2++ = *s;
						*d2++ = *s;
						s++;
					}
					*/
					lpDist += 2*ddsd.lPitch;
					lpSrc += WIDTH;
				}
			}
		}
		else if (ddsd.ddpfPixelFormat.dwFlags & DDPF_RGB)
		{
			lpDist += (dwDistX&~1)*ddsd.ddpfPixelFormat.dwRGBBitCount/8;
			for (i = 0; i < H; i++)
			{
				BYTE	*d, *d2, *s;
				DWORD	l, ll;
				int		j;

				d = lpDist;
				d2 = lpDist + ddsd.lPitch;
				s = lpSrc;
				switch (ddsd.ddpfPixelFormat.dwRGBBitCount/8)
				{
				case 2:
					__asm {
						push	esi
						push	edi
						mov		ax,ds
						mov		es,ax
						mov		ecx,W
						mov		edi,d
						mov		esi,s
						mov		ebx,offset PalTable
						xor		eax,eax
				lp2_2:
						lodsb
						mov		eax,[ebx+eax*4]
						mov		edx,eax
						shl		eax,16
						mov		ax,dx
						stosd
						xor		eax,eax
						loop	lp2_2
						mov		ecx,W
						mov		esi,lpDist
						mov		edi,d2
					rep	movsd
						pop		edi
						pop		esi
					}
					break;

				case 3:
					__asm {
						push	esi
						push	edi
						mov		ax,ds
						mov		es,ax
						mov		ecx,W
						mov		edi,d
						mov		esi,s
						mov		ebx,offset PalTable
						xor		eax,eax
				lp2_3:
						lodsb
						mov		eax,[ebx+eax*4]
						mov		edx,eax
						bswap	eax
						mov		al,dl
						bswap	eax
						shr		edx,8
						stosd
						xchg	eax,edx
						stosw
						xor		eax,eax
						loop	lp2_3
						mov		esi,lpDist
						mov		edi,d2
						mov		ecx,W
						lea		ecx,[ecx+ecx*2]
						shr		ecx,1
					rep	movsd
						pop		edi
						pop		esi
					}
					/*
					for (j = 0; j < W; j++)
					{
						l = PalTable[*s++];
						*((WORD *)d) = (WORD)(l&0xFFFF);
						d += 2;
						*d++ = (BYTE)(l>>16);
						*((WORD *)d) = (WORD)(l&0xFFFF);
						d += 2;
						*d++ = (BYTE)(l>>16);
						*((WORD *)d2) = (WORD)(l&0xFFFF);
						d2 += 2;
						*d2++ = (BYTE)(l>>16);
						*((WORD *)d2) = (WORD)(l&0xFFFF);
						d2 += 2;
						*d2++ = (BYTE)(l>>16);
					}
					*/
					break;
				case 4:
					__asm {
						push	esi
						push	edi
						mov		ax,ds
						mov		es,ax
						mov		ecx,W
						mov		edi,d
						mov		esi,s
						mov		edx,d2
						mov		ebx,offset PalTable
						xor		eax,eax
				lp2_4:
						lodsb
						mov		eax,[ebx+eax*4]
						stosd
						stosd
						xor		eax,eax
						loop	lp2_4
						mov		ecx,W
						add		ecx,ecx
						mov		esi,lpDist
						mov		edi,d2
					rep	movsd
						pop		edi
						pop		esi
					}
					break;

				default:
					for (j = 0; j < W; j++)
					{
						ll = PalTable[*s++];
						l = ll;
						for (int k = 0; k < (int)ddsd.ddpfPixelFormat.dwRGBBitCount/8; k++)
						{
							*d++ = (BYTE)(l&0xFF);
							l >>= 8;
						}
						l = ll;
						for (k = 0; k < (int)ddsd.ddpfPixelFormat.dwRGBBitCount/8; k++)
						{
							*d++ = (BYTE)(l&0xFF);
							l >>= 8;
						}
						l = ll;
						for (k = 0; k < (int)ddsd.ddpfPixelFormat.dwRGBBitCount/8; k++)
						{
							*d2++ = (BYTE)(l&0xFF);
							l >>= 8;
						}
						l = ll;
						for (k = 0; k < (int)ddsd.ddpfPixelFormat.dwRGBBitCount/8; k++)
						{
							*d2++ = (BYTE)(l&0xFF);
							l >>= 8;
						}
					}
				}
				lpDist += 2*ddsd.lPitch;
				lpSrc += WIDTH;
			}
		}
	}

	lpBackSurface->Unlock(NULL);

	DisplayInfo(lpBackSurface);

	if (bFullScreen)
	{
	//	if (dwTime < dwOldTime + 900*(UPeriod + 1)/60)
	//		WaitForSingleObject(hEventHsyncTimer, INFINITE);
	//	dwOldTime = dwTime;
		if (bActiveApp)
		{
			ddret = lpPrimarySurface->Flip(NULL, DDFLIP_WAIT);
			if (ddret == DDERR_SURFACELOST)
			{
				if (!RestoreSurfaces())
					return;
			}
		}
	}
	else
	{
		rcSrc.right = 320*((curMode&1)+1);
		rcSrc.bottom = 240*((curMode&1)+1);

//		ddret = lpPrimarySurface->BltFast(rcWnd.left, rcWnd.top, lpBackSurface, &rcSrc, 0);
		ddret = lpPrimarySurface->Blt(&rcWnd, lpBackSurface, &rcSrc, DDBLT_WAIT, NULL);
		if (ddret == DDERR_SURFACELOST)
		{
			if (!RestoreSurfaces())
				return;
		}
	}
}
/*
void CALLBACK TimerCallBack(UINT uID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
	switch (dwUser)
	{
	case 0:
		// EFCĝ߂HSYNC荞
		SetEvent(hEventHsyncTimer);
		break;

	case 1:
		// Huc6280^C}[
//		io.timer_counter -= 7;
//		if (io.timer_counter > 128)
//		{
//			io.timer_counter = io.timer_reload;
//			io.irq_status |= 0x04;
//		}
		break;
	}
}
*/

BOOL IsSupportMMX(void)
{
	int	bSupport = 0;

#define cpuid __asm _emit 0x0F _asm _emit 0xA2
	__asm {
		pushfd
		pop		eax
		xor		eax,00200000h
		push	eax
		popfd
		pushfd
		pop		edx
		cmp		eax,edx
		jne		NotSupport
		xor		eax,eax
		cpuid
		or		eax,eax
		jz		NotSupport
		mov		eax,1
		cpuid
		test	edx,00800000h
		jz		NotSupport
		mov		bSupport,1
	NotSupport:
	}
	TRACE("SupportMMX = %d\n", bSupport);
	return bSupport;
}

BOOL InitMachine(void)
{
	if( Verbose ) 
		TRACE("Initializing Hardware\n");

	XBuf = (BYTE *)malloc(sizeof(char) * WIDTH * HEIGHT);
	if( !XBuf )
	{
		if( Verbose )
			TRACE("FAILED\n");
		return 0; 
	}
	hEventNotify = CreateEvent(NULL, FALSE, FALSE, NULL);
	if (hEventNotify == NULL)
		return 0;
	hEventEndCommand = CreateEvent(NULL, FALSE, FALSE, NULL);
	if (hEventEndCommand == NULL)
		return 0;

	SupportMMX = IsSupportMMX();
/*	hEventHsyncTimer = CreateEvent(NULL, FALSE, FALSE, NULL);
	if (hEventHsyncTimer == NULL)
		return 0;
	UINT uRes = 2800*(UPeriod+1)/60;
	uHsyncTimerID = timeSetEvent(uRes, 0, TimerCallBack, 0, TIME_PERIODIC | TIME_CALLBACK_FUNCTION);
	if (uHsyncTimerID == NULL)
		return 0;

	uTimerID = timeSetEvent(1, 0, TimerCallBack, 1, TIME_PERIODIC | TIME_CALLBACK_FUNCTION);
	if (uTimerID == NULL)
		return 0;
*/
#ifdef SOUND
	InitSound(snd_bSound);
//	SetChannels(SndVolume,SndSwitch);
//	SetSound(3,SND_NOISE);
#endif SOUND

	HRESULT	ddret;
	DDSURFACEDESC	ddsd;
	BYTE	*lpDDMemory;

	memset(&ddsd, 0, sizeof(DDSURFACEDESC));
	ddsd.dwSize = sizeof(ddsd);
	ddret = lpBackSurface->Lock(NULL, &ddsd, 0, NULL);
	if (FAILED(ddret))
	{
		TRACE0("Locks\n");
		return FALSE;
	}

	lpDDMemory = (BYTE *)ddsd.lpSurface;
	memset(lpDDMemory, 0, ddsd.dwHeight * ddsd.lPitch);
	lpBackSurface->Unlock(NULL);

#ifdef USE_JOYSTICK
	InitDInput();
#endif // USE_JOYSTICK

	InitInfo();

	return TRUE;
}

void TrashMachine(void)
{
	if( Verbose ) TRACE("Shutting down...\n");
	if (XBuf) free(XBuf);

#ifdef SOUND
	TrashSound();
#endif 

#ifdef USE_JOYSTICK
	ReleaseDInput();
#endif // USE_JOYSTICK

	TrashInfo();

/*	if (uHsyncTimerID)
		timeKillEvent(uHsyncTimerID);
	if (hEventHsyncTimer)
		CloseHandle(hEventHsyncTimer);
	if (uTimerID)
		timeKillEvent(uTimerID);
*/	if (hEventNotify)
		CloseHandle(hEventNotify);
}

extern char *cart_name;

char *GetSaveFileName(void)
{
	static char save_filename[MAX_PATH];
	char *period, *yen;

	period = strrchr(cart_name, '.');
	yen = strrchr(cart_name, '\\');
	if (yen == NULL)
		yen = cart_name - 1;
	if (period == NULL)
		period = cart_name - 1;

	if (0 == strcmp(save_dir, ".") || save_dir[0]=='\0')
	{
		if (yen >= cart_name)
		{
			strncpy(save_filename, cart_name, yen-cart_name+1);
			save_filename[yen-cart_name+1] = '\0';
		}
	}
	else
	{
		if (0 != _access(save_dir, 0x00))
			_mkdir(save_dir);
		strcpy(save_filename, save_dir);
		strcat(save_filename, "\\");
	}

	if (yen < period)
		strncat(save_filename, yen+1, period-yen-1);
	else
		strcat(save_filename, yen+1);
	strcat(save_filename, ".st0");
	TRACE("save_filename = %s\n", save_filename);
	return save_filename;
}

#define	VRAMSIZE	0x20000

extern byte RAM[], PopRAM[], *VRAM, *vchange, *vchanges;
extern byte *Page[];
extern short SPRAM[];
extern unsigned long *VRAM2;
extern byte Pal[];
extern int scanline;
extern IO io;
extern M6502 M;
extern void bank_set(byte P,byte V);

void SaveState(void)
{
	FILE *fp;

	fp = fopen(GetSaveFileName(), "wb");
	if (fp == NULL)
	{
		TRACE("Can't open save file\n");
		return;
	}
	fwrite(RAM, 1, 0x8000, fp);
	fwrite(VRAM, 1, VRAMSIZE, fp);
//	fwrite(vchange, 1, VRAMSIZE/32, fp);
	fwrite(SPRAM, 1, 64*4*sizeof(short), fp);
//	fwrite(VRAM2, 1, VRAMSIZE, fp);
	fwrite(Pal, 1, 512, fp);
	fwrite(&scanline, 1, sizeof(int), fp);
	fwrite(&io, 1, sizeof(IO), fp);
	fwrite(&M, 1, sizeof(M6502), fp);
	if (populus)
		fwrite(PopRAM, 1, 0x8000, fp);

	fclose(fp);
	SetInfoString("State saved");
}

void LoadState(void)
{
	FILE *fp;
	int	len;

	fp = fopen(GetSaveFileName(), "rb");
	if (fp == NULL)
	{
		TRACE("Can't open save file\n");
		SetInfoString("Can't open state file");
		return;
	}
	len = _filelength(_fileno(fp));
	if (len != 301500+(populus? 32768:0) &&
		len != 166336+(populus? 32768:0))
	{
		TRACE("Bad state save file\n");
		SetInfoString("Bad state file");
		return;
	}
	fread(RAM, 1, 0x8000, fp);
	fread(VRAM, 1, VRAMSIZE, fp);
	if (len==301500)
		fread(vchange, 1, VRAMSIZE/32, fp);
	fread(SPRAM, 1, 64*4*sizeof(short), fp);
	if (len==301500)
		fread(VRAM2, 1, VRAMSIZE, fp);
	fread(Pal, 1, 512, fp);
	fread(&scanline, 1, sizeof(int), fp);
	fread(&io, 1, sizeof(IO), fp);
	if (len==301500)
	{
		byte *p = (byte*)&M+offsetof(M6502,NF);
		fread(&M, 1, sizeof(M6502)-4, fp);
		memmove(p+4,p,sizeof(M6502)-offsetof(M6502,NF)-4);
		M.ZF=!(M.P&0x02); M.VF=M.NF=M.P;
	}
	else
		fread(&M, 1, sizeof(M6502), fp);
	if (populus)
		fread(PopRAM, 1, 0x8000, fp);
	for (int i = 0; i < 8; i++)
		bank_set(i, M.MPR[i]);
	memset(vchange, 1, VRAMSIZE/32);
	memset(vchanges, 1, VRAMSIZE/128);

	fclose(fp);
	SetInfoString("State loaded");
}

#define	JOY_A	1
#define	JOY_B	2
#define	JOY_SELECT	4
#define	JOY_START	8
#define	JOY_UP	0x10
#define	JOY_DOWN	0x40
#define	JOY_LEFT	0x80
#define	JOY_RIGHT	0x20

BYTE	aKeyState[256];

int Joysticks(void)
{
	int JS;

	GetKeyboardState(aKeyState);

#define	KEY(__a)	(aKeyState[__a]&0x80)

	JS = 0x0000;

	static int	oldKeyA, oldKeyS;
//	static int	isRensyaA, isRensyaS;
	static int	press_countA, press_countS;
	static int	oldKey1, oldKey2;
	static int	oldKeyF5, oldKeyF6;
	extern byte BGONSwitch, SPONSwitch;
	static int oldKeyAltEnter;
	static int oldKeyF8;
	static int oldKeyF7;
	static int oldKeyF3, oldKeyF4, oldKeyF2;
	static int down, left;
//	int		KeyA, KeyS;
	int		Key1, Key2;
	int		KeyF5, KeyF6;
	int		KeyAltEnter;
	int		KeyF8;
	int		KeyF7;
	int		KeyF3, KeyF4, KeyF2;
	DWORD	ev;
	BOOL	bRensyaA = FALSE;
	BOOL	bRensyaB = FALSE;
	BOOL	bFrameSkipChanged = FALSE;
	char	szBuf[256];

	if (WAIT_OBJECT_0 == WaitForSingleObject(hEventNotify, 0))
		ev = dwEvent;
	else
		ev = 0;

	if (ev & EV_CARTLOAD)
	{
		if (0 ==_access(pCartName, 00))
		{
			cart_reload = 1;
			return 0x10000;
		}
	}

#ifdef USE_JOYSTICK
	if (lpJoystick)
	{
		HRESULT	diret;
		DIJOYSTATE	js;

		lpJoystick->Poll();
		diret = lpJoystick->GetDeviceState(sizeof(DIJOYSTATE), &js);
		if (FAILED(diret))
		{
			if (bActiveApp && (diret == DIERR_INPUTLOST || diret == DIERR_NOTACQUIRED))
			{
				if (!AcquireInput())
					goto JOYSTICK_ERROR_BREAK;
				lpJoystick->Poll();
				diret = lpJoystick->GetDeviceState(sizeof(DIJOYSTATE), &js);
			}
			if (FAILED(diret))
			{
			/*	TCHAR	szBuf[1024];
				wsprintf(szBuf, "GetDeviceState failed (code=%d)\n", diret);
				//TRACE("GetDeviceState failed\n");
				TRACE(szBuf);
				AfxMessageBox(szBuf);
			*/	goto JOYSTICK_ERROR_BREAK;
			}
		}
		if (js.lX < 0)
			JS |= JOY_LEFT;
		else if (js.lX > 0)
			JS |= JOY_RIGHT;
		if (js.lY < 0)
			JS |= JOY_UP;
		else if (js.lY > 0)
			JS |= JOY_DOWN;
		if (js.rgbButtons[ksJoy1] & 0x80)
			JS |= JOY_A;
		if (js.rgbButtons[ksJoy2] & 0x80)
			JS |= JOY_B;
		if (js.rgbButtons[ksJoy11] & 0x80)
			bRensyaA = TRUE;
		if (js.rgbButtons[ksJoy22] & 0x80)
			bRensyaB = TRUE;
		if (js.rgbButtons[ksJoyRun] & 0x80)
			JS |= JOY_START;
		if (js.rgbButtons[ksJoySel] & 0x80)
			JS |= JOY_SELECT;
JOYSTICK_ERROR_BREAK:
		;
	}
#endif // USE_JOYSTICK

	KeyAltEnter = (KEY(VK_MENU) && KEY(VK_RETURN)) ? 1 : 0;
	if (KeyAltEnter && oldKeyAltEnter == 0 || (ev & EV_FULLSCREEN))
	{
		PostMessage(hwnd, WM_CHANGEWINDOWMODE, 0, 0);
		WaitForSingleObject(hEventEndCommand, INFINITE);
	}
	oldKeyAltEnter = KeyAltEnter;

	KeyF8 = KEY(VK_F8) ? 1 : 0;
	if (KeyF8 && oldKeyF8 == 0 || (ev & EV_ZOOM))
		ZoomWindow();
	oldKeyF8 = KeyF8;

	KeyF7 = KEY(VK_F7) ? 1 : 0;
	if (KeyF7 && oldKeyF7 == 0)
		bShowFps = !bShowFps;
	oldKeyF7 = KeyF7;
/*
	KeyA = KEY('A');
	if (KeyA && oldKeyA == 0)
		isRensyaA = 1 - isRensyaA;
	oldKeyA = KeyA ? 1 : 0;
	KeyS = KEY('S');
	if (KeyS && oldKeyS == 0)
		isRensyaS = 1 - isRensyaS;
	oldKeyS = KeyS ? 1 : 0;
*/
	if(KEY(ksKey11) || bRensyaA)
	{
		if (press_countA++ >= 2)
		{
			JS |= JOY_A;
			press_countA = 0;
		}
	}
	if(KEY(ksKey22) || bRensyaB)
	{
		if (press_countS++ >= 2)
		{
			JS |= JOY_B;
			press_countS = 0;
		}
	}

	if(KEY(VK_ESCAPE) || KEY(VK_MENU)&&KEY(VK_F4) || KEY(VK_F10) || (ev & EV_STOP))
		JS|=0x10000;
	if(KEY(ksKey1))
		JS|=JOY_A;
	if(KEY(ksKey2))
		JS |= JOY_B;
	if(KEY(ksKeyRun) && !KeyAltEnter)	JS |= JOY_START;
	if(KEY(ksKeySel))		JS |= JOY_SELECT;
	if(KEY(ksKeyDown))	JS |= JOY_DOWN;
	if(KEY(ksKeyUp))		JS |= JOY_UP;
	if ((JS&(JOY_DOWN|JOY_UP))==(JOY_DOWN|JOY_UP))
	{
		if (down)
			JS &= ~JOY_DOWN;
		else
			JS &= ~JOY_UP;
	}
	else
		down = JS&JOY_DOWN;
	if(KEY(ksKeyLeft))	JS |= JOY_LEFT;
	if(KEY(ksKeyRight))	JS |= JOY_RIGHT;
	if ((JS&(JOY_LEFT|JOY_RIGHT))==(JOY_LEFT|JOY_RIGHT))
	{
		if (left)
			JS &= ~JOY_LEFT;
		else
			JS &= ~JOY_RIGHT;
	}
	else
		left = JS&JOY_LEFT;

	Key1 = KEY('1');
	if(Key1 && oldKey1 == 0)
		BGONSwitch = 1 - BGONSwitch;
	oldKey1 = Key1 ? 1 : 0;
	Key2 = KEY('2');
	if(Key2 && oldKey2 == 0)
		SPONSwitch = 1 - SPONSwitch;
	oldKey2 = Key2 ? 1 : 0;

	KeyF5 = KEY(VK_F5);
	if (KeyF5 && oldKeyF5 == 0 || (ev & EV_SAVE))
		SaveState();
	oldKeyF5 = KeyF5 ? 1 : 0;
	KeyF6 = KEY(VK_F6);
	if (KeyF6 && oldKeyF6 == 0 || (ev & EV_LOAD))
	LoadState();
	oldKeyF6 = KeyF6 ? 1 : 0;

	KeyF3 = KEY(VK_F3);
	if (KeyF3 && oldKeyF3 == 0 || (ev & EV_DOWNSKIPRATE))
	{
		if (UPeriod > 0)
			UPeriod--;
		bFrameSkipChanged = TRUE;
	}
	oldKeyF3 = KeyF3 ? 1 : 0;
	KeyF4 = KEY(VK_F4);
	if (KeyF4 && oldKeyF4 == 0 || (ev & EV_UPSKIPRATE))
	{
		if (UPeriod < 15)
			UPeriod++;
		bFrameSkipChanged = TRUE;
	}
	oldKeyF4 = KeyF4 ? 1 : 0;
	KeyF2 = KEY(VK_F2);
	if (KeyF2 && oldKeyF2 == 0 || (ev & EV_AUTOFRAMESKIP))
	{
		bAutoFrameSkip = !bAutoFrameSkip;
		bFrameSkipChanged = TRUE;
	}
	oldKeyF2 = KeyF2 ? 1 : 0;

	if (bFrameSkipChanged)
	{
		if (bAutoFrameSkip)
			wsprintf(szBuf, "FrameSkip:%d(auto)", UPeriod);
		else
			wsprintf(szBuf, "FrameSkip:%d", UPeriod);
		SetInfoString(szBuf);
	}

	if (ev & EV_RESET)
		ResetPCE(&M);

	return JS;
}
